#include "ah.h"

IMPLEMENT_DYNCREATE(CAhWin, CFrameWnd)

BEGIN_DISPATCH_MAP(CAhWin, CFrameWnd)
   DISP_FUNCTION(CAhWin, "UserAdd", UserAdd, VT_EMPTY, VTS_NONE)
   DISP_FUNCTION(CAhWin, "DropUser", DropUser, VT_EMPTY, VTS_NONE)
   DISP_FUNCTION(CAhWin, "NumUsers", NumUsers, VT_I4, VTS_NONE)
   DISP_FUNCTION(CAhWin, "AddArray", AddArray, VT_I4, VTS_I4)
   DISP_FUNCTION(CAhWin, "RemoveArray", RemoveArray, VT_BOOL, VTS_I4)
   DISP_FUNCTION(CAhWin, "SetRecord", SetRecord, VT_I4, VTS_I4 VTS_I4 VTS_I4)
   DISP_FUNCTION(CAhWin, "GetRecord", GetRecord, VT_I4, VTS_I4 VTS_I4)
   DISP_FUNCTION(CAhWin, "Close", Close, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()

IMPLEMENT_OLECREATE2(CAhWin, "ah.Server",
   0xe68c8195, 0x53e7, 0x11d3, 0x8a, 0x9, 0x0, 0x8, 0xc7, 0x1b, 0x52, 0xd7)

CAhWin::CAhWin()
{
   Create(NULL, _T("Array Handler"), WS_OVERLAPPEDWINDOW, rectDefault);
   m_bAutoDelete = TRUE;
   m_dwRegister = 0;
   NumOfUsers = 0;
   EnableAutomation();
}

CAhWin::~CAhWin()
{
   if (m_dwRegister != 0)
      RevokeActiveObject(m_dwRegister, NULL);
}

void CAhWin::UserAdd()
{
   NumOfUsers++;
   return;
}

void CAhWin::DropUser()
{
   if (NumOfUsers > 0)
      NumOfUsers--;
   return;
}

UINT CAhWin::NumUsers()
{
   return NumOfUsers;
}

UINT CAhWin::AddArray(UINT size)
{
   return ah.Add(size);
}

BOOL CAhWin::RemoveArray(UINT arraynum)
{
   return ah.Remove(arraynum);
}

BOOL CAhWin::SetRecord(UINT arraynum, UINT recnum, UINT value)
{
   return ah.Set(arraynum, recnum, value);
}

UINT CAhWin::GetRecord(UINT arraynum, UINT recnum)
{
   return ah.Get(arraynum, recnum);
}

void CAhWin::Close()
{
   if (m_hWnd == NULL)
   {
      AfxPostQuitMessage(0);
      return;
   }
   BOOL bAutoDelete = m_bAutoDelete;
   m_bAutoDelete = FALSE;
   DestroyWindow();
   m_bAutoDelete = bAutoDelete;
}

BOOL CAhWin::RegisterActive()
{
   return RegisterActiveObject(GetInterface(&IID_IUnknown),
      CAhWin::guid, NULL, &m_dwRegister) == NOERROR;
}

void CAhWin::PostNcDestroy()
{
   if (m_bAutoDelete)
      delete this;
}
